package myapplicationmodulelistenerapp.common;

import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicInteger;

public class IdShortener
{
	private String fIdPrefix = null;
	private AtomicInteger fIdSeq = null;

	private ConcurrentHashMap fShortIdMap = new ConcurrentHashMap();

	public IdShortener(String pIdPrefix, int pIdInitialValue)
	{
		fIdPrefix = pIdPrefix;
		fIdSeq = new AtomicInteger(pIdInitialValue);
	}

	public String getShortId(Object pId, IdShortenerListener pIdShortenerListener)
	{
		String vShortId = (String)fShortIdMap.get(pId);
		if (vShortId == null)
		{
			vShortId = fIdPrefix + fIdSeq.getAndIncrement();
			String vExistingShortId =
				(String)fShortIdMap.putIfAbsent(pId, vShortId);
			if (vExistingShortId != null)
			{
				return vExistingShortId;
			}
			else
			{
				pIdShortenerListener.onNewShortId(vShortId, pId);
			}
		}
		return vShortId;
	}
}
