package myapplicationmodulelistenerapp.common;

import java.util.concurrent.atomic.AtomicInteger;

public class MyRequestContext
{
	private static final AtomicInteger MY_REQUEST_CONTEXT_ID_SEQ = new AtomicInteger(31);
	private final String fMyRequestContextId = "ctx" + MY_REQUEST_CONTEXT_ID_SEQ.getAndIncrement();

	protected MyApplicationModuleListener fMyApplicationModuleListener = null;
	protected MyApplicationModuleListener fDefaultMyApplicationModuleListener =
		new MyApplicationModuleListenerBaseImpl()
			{
				@Override
				protected String getLogPrefix()
				{
					// dL = default listener
					return "[dL]";
				}
			};

	protected MyRequestContext()
	{}

	private static ThreadLocal<MyRequestContext> fCurrentInstance =
		new ThreadLocal<MyRequestContext>()
	{
		@Override
		protected MyRequestContext initialValue()
		{
			return new MyRequestContext();
		}
	};
	
	public static MyRequestContext getCurrentInstance()
	{
		return fCurrentInstance.get();
	}
	
	public String getMyRequestContextId()
	{
		return fMyRequestContextId;
	}

	public void setMyApplicationModuleListener(
		MyApplicationModuleListener pMyApplicationModuleListener)
	{
		fMyApplicationModuleListener = pMyApplicationModuleListener;
	}

	public MyApplicationModuleListener getMyApplicationModuleListener()
	{
		if (fMyApplicationModuleListener == null)
		{
			return fDefaultMyApplicationModuleListener;
		}
		return fMyApplicationModuleListener;
	}
}
