package myapplicationmodulelistenerapp.view;

import java.io.IOException;
import java.io.PrintWriter;

import java.util.List;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import myapplicationmodulelistenerapp.common.PoolMgrHelper;

import oracle.jbo.common.ampool.ApplicationPool;


public class MyDumpPoolStatisticsServlet
	extends HttpServlet
{
	private static final String CONTENT_TYPE = "text/html; charset=UTF-8";

	public void init(ServletConfig pConfig)
		throws ServletException
	{
		super.init(pConfig);
	}

	public void doGet(HttpServletRequest pRequest,
		HttpServletResponse pResponse)
		throws ServletException, IOException
	{
		pResponse.setContentType(CONTENT_TYPE);
		PrintWriter vOut = pResponse.getWriter();
		vOut.println("<html>");
		vOut.println("<head><title>MyDumpPoolStatisticsServlet</title></head>");
		vOut.println("<body>");
		vOut.println("<div>MyDumpPoolStatisticsServlet</div>");

		List<ApplicationPool> vAllApplicationPools = null;
		try
		{
			vAllApplicationPools = PoolMgrHelper.getAllApplicationPools();
		}
		catch (Exception ex)
		{
			throw new ServletException(
				"unable to get all ApplicationPools, ex = " + ex, ex);
		}
		vOut.println("<div>vAllApplicationPools.size() = "
			+ vAllApplicationPools.size() + "</div>");
		for (ApplicationPool vApplicationPool : vAllApplicationPools)
		{
			printApplicationPoolInfo(vOut, vApplicationPool);
		}

		vOut.println("</body></html>");
		vOut.close();
	}

	protected void printApplicationPoolInfo(PrintWriter pOut,
		ApplicationPool pApplicationPool)
	{
		pOut.println("<div>ApplicationPool = " + pApplicationPool.getName() + "</div>");
		PoolMgrHelper vPoolMgrHelper = getPoolMgrHelper();
		String vStatisticsInOneLine = vPoolMgrHelper.getStatisticsInOneLine(pApplicationPool);
		pOut.println("<div>" + vStatisticsInOneLine + "</div>");
	}

	protected PoolMgrHelper getPoolMgrHelper()
	{
		return PoolMgrHelper.getDefaultInstance();
	}
}