package myapplicationmodulelistenerapp.view;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import oracle.adf.controller.v2.lifecycle.Lifecycle;
import oracle.adf.controller.v2.lifecycle.PagePhaseEvent;
import oracle.adf.controller.v2.lifecycle.PagePhaseListener;

public class MyLogPagePhaseListener
	implements PagePhaseListener
{
	public void beforePhase(PagePhaseEvent pPagePhaseEvent)
	{
		System.out.println("MyLogPagePhaseListener.beforePhase()"
			+ " : " + getPhaseName(pPagePhaseEvent)
			+ " : " + getPathInfo());
	}

	public void afterPhase(PagePhaseEvent pPagePhaseEvent)
	{
		System.out.println("MyLogPagePhaseListener.afterPhase()"
			+ "  : " + getPhaseName(pPagePhaseEvent));
	}

	public static String getPhaseName(PagePhaseEvent pPagePhaseEvent)
	{
		int vPhaseId = pPagePhaseEvent.getPhaseId();
		return "(" + (vPhaseId < 10 ? " " + vPhaseId: "" + vPhaseId) + ") " +
				 Lifecycle.getPhaseName(vPhaseId);
	}

	public static String getPathInfo()
	{
		FacesContext vFacesContext = FacesContext.getCurrentInstance();
		ExternalContext vExternalContext =
			vFacesContext.getExternalContext();
		String vRequestServletPath =
			vExternalContext.getRequestServletPath();
		String vRequestPathInfo = vExternalContext.getRequestPathInfo();
		return vRequestServletPath + " : " + vRequestPathInfo;
	}
}
