package myapplicationmodulelistenerapp.view;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

import myapplicationmodulelistenerapp.common.MyApplicationModuleListener;
import myapplicationmodulelistenerapp.common.MyRequestContext;

import oracle.adf.controller.faces.lifecycle.JSFLifecycle;
import oracle.adf.controller.v2.lifecycle.PagePhaseEvent;
import oracle.adf.controller.v2.lifecycle.PagePhaseListener;


public class MyRequestMAMListenerPagePhaseListener
	implements PagePhaseListener
{
	protected static String fMyApplicationModuleListenerEL =
		"#{theMyApplicationModuleListener}";

	public void beforePhase(PagePhaseEvent pPagePhaseEvent)
	{
		if (JSFLifecycle.JSF_RESTORE_VIEW_ID == pPagePhaseEvent.getPhaseId())
		{
			configureMyRequestMAMListener();
		}
	}

	public void afterPhase(PagePhaseEvent pPagePhaseEvent)
	{
	}

	public static void setMyApplicationModuleListenerEL(
		String pMyApplicationModuleListenerEL)
	{
		fMyApplicationModuleListenerEL = pMyApplicationModuleListenerEL;
	}

	public void configureMyRequestMAMListener()
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			getMyApplicationModuleListenerFromEL();
		if (vMyApplicationModuleListener == null)
		{
			vMyApplicationModuleListener =
				new MyRequestMyApplicationModuleListener();
		}

		if (vMyApplicationModuleListener instanceof MyRequestMyApplicationModuleListener)
		{
			String vRequestInfoPrefix = getRequestInfoPrefix();
			MyRequestMyApplicationModuleListener vMyRequestMyApplicationModuleListener =
				(MyRequestMyApplicationModuleListener)vMyApplicationModuleListener;
			vMyRequestMyApplicationModuleListener.setRequestInfoPrefix(vRequestInfoPrefix);
		}

		MyRequestContext vMyRequestContext = MyRequestContext.getCurrentInstance();
		vMyRequestContext.setMyApplicationModuleListener(vMyApplicationModuleListener);
	}

	public String getRequestInfoPrefix()
	{
		FacesContext vFacesContext = FacesContext.getCurrentInstance();
		ExternalContext vExternalContext =
			vFacesContext.getExternalContext();
		String vRequestServletPath =
			vExternalContext.getRequestServletPath();
		String vRequestPathInfo = vExternalContext.getRequestPathInfo();

		MyRequestContext vMyRequestContext = MyRequestContext.getCurrentInstance();
		String vMyRequestContextId = vMyRequestContext.getMyRequestContextId();
		return "(" + vMyRequestContextId + ") "
			+ vRequestServletPath + " : " + vRequestPathInfo;

//		return vRequestServletPath + " : " + vRequestPathInfo;
	}

	public MyApplicationModuleListener getMyApplicationModuleListenerFromEL()
	{
		return (MyApplicationModuleListener)ELHelper.get(
			fMyApplicationModuleListenerEL);
	}
}
