package myapplicationmodulelistenerapp.view;

import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

import javax.servlet.http.HttpServletRequest;

import myapplicationmodulelistenerapp.common.MyApplicationModuleListenerBaseImpl;

import oracle.adf.view.rich.context.AdfFacesContext;


public class MyRequestMyApplicationModuleListener
	extends MyApplicationModuleListenerBaseImpl
{
	private static final AtomicInteger MY_REQUEST_MAM_LISTENER_ID_SEQ =
		new AtomicInteger(1001);
	protected final String fMyRequestMAMListenerId =
		"r" + MY_REQUEST_MAM_LISTENER_ID_SEQ.getAndIncrement();

	protected String fRequestInfoPrefix = "default-ri";

	public MyRequestMyApplicationModuleListener()
	{
//		log("new MyRequestMyApplicationModuleListener");
	}

	public void setRequestInfoPrefix(String pRequestInfoPrefix)
	{
		fRequestInfoPrefix = pRequestInfoPrefix;
//		log("setRequestInfoPrefix() : extra " + getExtraRequestInfo());
	}

	protected String getExtraRequestInfo()
	{
		FacesContext vFacesContext = FacesContext.getCurrentInstance();
		ExternalContext vExternalContext = vFacesContext.getExternalContext();
		HttpServletRequest vRequest = (HttpServletRequest)vExternalContext.getRequest();
		String vInfo = "[" + vRequest.getMethod();
		Map vParameterMap = vRequest.getParameterMap();
		vInfo = vInfo + " with " + vParameterMap.size() + " parameters";
		AdfFacesContext vAdfFacesContext = AdfFacesContext.getCurrentInstance();
		boolean vIsPartialRequest = vAdfFacesContext.isPartialRequest(vFacesContext);
		vInfo = vInfo + " (partial request " + vIsPartialRequest + ")";
		boolean vIsInitialRender = vAdfFacesContext.isInitialRender();
		vInfo = vInfo + " (initial render " + vIsInitialRender + ")";
		boolean vIsPostback = vAdfFacesContext.isPostback();
		vInfo = vInfo + " (postback " + vIsPostback + ")";
		return vInfo + "]";
	}

	@Override
	protected String getLogPrefix()
	{
		return super.getLogPrefix() + "[" + fMyRequestMAMListenerId + "]"
			+ "[" + fRequestInfoPrefix + "] ";
	}

	@Override
	public String getJDBCDataSourceRuntimeMBeanNameForJDBCDataSourceName(
		String pJDBCDataSourceName)
	{
		// TODO review this (second part of a) buggy workaround,
		// and replace it with a proper generic solution
		// see also forum thread "finding runtime MBean for DataSource JNDI name"
		// at https://forums.oracle.com/forums/thread.jspa?threadID=2358275
		String vSelectedObjectName =
			MyQueryMBeansObjectsServlet.getSelectedObjectName();
		if (vSelectedObjectName != null)
		{
			return vSelectedObjectName;
		}
		return super.getJDBCDataSourceRuntimeMBeanNameForJDBCDataSourceName(
			pJDBCDataSourceName);
	}
}
