package myapplicationmodulelistenerapp.common;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

import oracle.jbo.ApplicationModule;
import oracle.jbo.ApplicationPoolSvcMsgContext;
import oracle.jbo.common.NamedObjectImpl;
import oracle.jbo.common.ampool.SessionCookie;
import oracle.jbo.common.ws.WSApplicationModuleMarshaller;
import oracle.jbo.server.ApplicationModuleImpl;
import oracle.jbo.server.DBTransaction;


public class MyAMInfoHelper
{
	protected MyAMInfoHelper()
	{}

	public static String getAMInfo(ApplicationModuleImpl pApplicationModuleImpl)
	{
		if (pApplicationModuleImpl == null)
		{
		return "[pApplicationModuleImpl == null]";
		}
		String vObjectInstanceIdInfo = "(?)";
		if (pApplicationModuleImpl instanceof MyObjectInstanceIdProvider)
		{
			MyObjectInstanceIdProvider vMyObjectInstanceIdProvider =
				(MyObjectInstanceIdProvider)pApplicationModuleImpl;
			vObjectInstanceIdInfo = "("
				+ vMyObjectInstanceIdProvider.getObjectInstanceId() + ")";
		}
		String vName = pApplicationModuleImpl.getName();
		boolean vIsRoot = pApplicationModuleImpl.isRoot();
//		int vReleaseLevel = pApplicationModuleImpl.getReleaseLevel();
		NamedObjectImpl vParent = pApplicationModuleImpl.getParent();
		return "[" + vObjectInstanceIdInfo
			+ " " + vName + " (" + (vIsRoot ? "is root" : "not root") + ")"
//			+ " " + getReleaseLevel(vReleaseLevel)
			+ (vIsRoot ? "" : " parent = " + getNOInfo(vParent)) + "]";
	}

	public static String queryOneRecord(
		ApplicationModuleImpl pApplicationModuleImpl, String pSQL)
	{
		DBTransaction vDBTransaction = pApplicationModuleImpl.getDBTransaction();
		PreparedStatement vPreparedStatement =
			vDBTransaction.createPreparedStatement(pSQL, 1);
		ResultSet vResultSet = null;
		String vOneRecord = null;
		try
		{
			vResultSet = vPreparedStatement.executeQuery();
			if (vResultSet.next())
			{
				ResultSetMetaData vResultSetMetaData = vResultSet.getMetaData();
				int vColumnCount = vResultSetMetaData.getColumnCount();
				int vColumn = 1;
				while (vColumn <= vColumnCount)
				{
					String vColumnName = vResultSetMetaData.getColumnName(vColumn);
					String vColumnValue = vResultSet.getString(vColumnName);
					vOneRecord = (vOneRecord != null ? ", " : "")
						+ vColumnName + " = " + vColumnValue;
					vColumn = vColumn + 1;
				}
			}
			else
			{
				vOneRecord = "ResultSet empty";
			}
		}
		catch (SQLException ex)
		{
			throw new RuntimeException("unable to execute query, ex = " + ex, ex);
		}
		return vOneRecord;
	}
	
	public static String getNOInfo(NamedObjectImpl pNamedObjectImpl)
	{
		if (pNamedObjectImpl == null)
		{
			return "(null)";
		}
		if (pNamedObjectImpl instanceof ApplicationModuleImpl)
		{
			return getAMInfo((ApplicationModuleImpl)pNamedObjectImpl);
		}
		else
		{
			return "[" + pNamedObjectImpl.getName() + "]";
		}
	}

	public static String getApplicationPoolSvcMsgContextRtnEventId(int pRtnEventId)
	{
		if (ApplicationPoolSvcMsgContext.POOL_EVENT_CONNECT == pRtnEventId)
		{
			return "POOL_EVENT_CONNECT (" + pRtnEventId + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_EVENT_FAILOVER == pRtnEventId)
		{
			return "POOL_EVENT_FAILOVER (" + pRtnEventId + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_EVENT_DISCONNECT_FAILOVER == pRtnEventId)
		{
			return "POOL_EVENT_DISCONNECT_FAILOVER (" + pRtnEventId + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_EVENT_PREPARE_SESSION == pRtnEventId)
		{
			return "POOL_EVENT_PREPARE_SESSION (" + pRtnEventId + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_EVENT_REMOVE == pRtnEventId)
		{
			return "POOL_EVENT_REMOVE (" + pRtnEventId + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_EVENT_ACTIVATE == pRtnEventId)
		{
			return "POOL_EVENT_ACTIVATE (" + pRtnEventId + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_EVENT_RESERVE_PASSIVATION_ID == pRtnEventId)
		{
			return "POOL_EVENT_RESERVE_PASSIVATION_ID (" + pRtnEventId + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_EVENT_AMSTATS_UPDATE == pRtnEventId)
		{
			return "POOL_EVENT_AMSTATS_UPDATE (" + pRtnEventId + ")";
		}
		return "unknown event id " + pRtnEventId;
	}

	public static String getApplicationPoolSvcMsgContextRequestOperation(int pRequestOperation)
	{
		if (ApplicationPoolSvcMsgContext.POOL_REQ_PASSIVATE_STATE == pRequestOperation)
		{
			return "POOL_REQ_PASSIVATE_STATE (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_ACTIVATE_STATE == pRequestOperation)
		{
			return "POOL_REQ_ACTIVATE_STATE (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_REMOVE_STATE == pRequestOperation)
		{
			return "POOL_REQ_REMOVE_STATE (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_RESET_STATE == pRequestOperation)
		{
			return "POOL_REQ_RESET_STATE (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_PREPARE_SESSION == pRequestOperation)
		{
			return "POOL_REQ_PREPARE_SESSION (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_HINT_PREPARE_SESSION == pRequestOperation)
		{
			return "POOL_REQ_HINT_PREPARE_SESSION (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_CONNECT == pRequestOperation)
		{
			return "POOL_REQ_CONNECT (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_DISCONNECT == pRequestOperation)
		{
			return "POOL_REQ_DISCONNECT (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_RECONNECT == pRequestOperation)
		{
			return "POOL_REQ_RECONNECT (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_REMOVE == pRequestOperation)
		{
			return "POOL_REQ_REMOVE (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_RESERVE_PASSIVATION_ID == pRequestOperation)
		{
			return "POOL_REQ_RESERVE_PASSIVATION_ID (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_SET_BUNDLED_EXCEPTION_MODE == pRequestOperation)
		{
			return "POOL_REQ_SET_BUNDLED_EXCEPTION_MODE (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_GET_AM_STATS == pRequestOperation)
		{
			return "POOL_REQ_GET_AM_STATS (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_ATTACH_LWS == pRequestOperation)
		{
			return "POOL_REQ_ATTACH_LWS (" + pRequestOperation + ")";
		}
		if (ApplicationPoolSvcMsgContext.POOL_REQ_DETACH_LWS == pRequestOperation)
		{
			return "POOL_REQ_DETACH_LWS (" + pRequestOperation + ")";
		}
		return "unknown request operation " + pRequestOperation;
	}

	public static String getApplicationPoolSvcMsgContextJDBCConnectionType(int pJDBCConnectionType)
	{
		if (ApplicationPoolSvcMsgContext.JDBC_DATASOURCE_CONNECTION_TYPE == pJDBCConnectionType)
		{
			return "JDBC_DATASOURCE_CONNECTION_TYPE (" + pJDBCConnectionType + ")";
		}
		if (ApplicationPoolSvcMsgContext.JDBC_URL_CONNECTION_TYPE == pJDBCConnectionType)
		{
			return "JDBC_URL_CONNECTION_TYPE (" + pJDBCConnectionType + ")";
		}
		if (ApplicationPoolSvcMsgContext.JDBC_NULL_CONNECTION_TYPE == pJDBCConnectionType)
		{
			return "JDBC_NULL_CONNECTION_TYPE (" + pJDBCConnectionType + ")";
		}
		return "unknown JDBC connection type " + pJDBCConnectionType;
	}

	public static String getApplicationPoolSvcMsgContextMessageType(int pMessageType)
	{
		String vMessageType = null;
		if ((pMessageType & ApplicationPoolSvcMsgContext.MESSAGE_TYPE_USING) > 0)
		{
			vMessageType = (vMessageType != null ? vMessageType + ", " : "") + "MESSAGE_TYPE_USING";
		}
		if ((pMessageType & ApplicationPoolSvcMsgContext.MESSAGE_TYPE_RELEASING) > 0)
		{
			vMessageType = (vMessageType != null ? vMessageType + ", " : "") + "MESSAGE_TYPE_RELEASING";
		}
		if ((pMessageType & ApplicationPoolSvcMsgContext.MESSAGE_TYPE_REMOVING) > 0)
		{
			vMessageType = (vMessageType != null ? vMessageType + ", " : "") + "MESSAGE_TYPE_REMOVING";
		}
		if ((pMessageType & ApplicationPoolSvcMsgContext.MESSAGE_TYPE_RECYCLING) > 0)
		{
			vMessageType = (vMessageType != null ? vMessageType + ", " : "") + "MESSAGE_TYPE_RECYCLING";
		}
		if ((pMessageType & ApplicationPoolSvcMsgContext.MESSAGE_TYPE_FINALIZING) > 0)
		{
			vMessageType = (vMessageType != null ? vMessageType + ", " : "") + "MESSAGE_TYPE_FINALIZING";
		}
		return (vMessageType != null ? vMessageType : "unknown message type")
			+ " (" + pMessageType + ")";
	}

	public static String getApplicationPoolSvcMsgContextStatus(int pStatus)
	{
		if (ApplicationPoolSvcMsgContext.STATUS_INITIALIZED == pStatus)
		{
			return "STATUS_INITIALIZED (" + pStatus + ")";
		}
		if (ApplicationPoolSvcMsgContext.STATUS_CONNECT_ERROR == pStatus)
		{
			return "STATUS_CONNECT_ERROR (" + pStatus + ")";
		}
		if (ApplicationPoolSvcMsgContext.STATUS_MT_ERROR == pStatus)
		{
			return "STATUS_MT_ERROR (" + pStatus + ")";
		}
		if (ApplicationPoolSvcMsgContext.STATUS_SUCCESS == pStatus)
		{
			return "STATUS_SUCCESS (" + pStatus + ")";
		}
		if (ApplicationPoolSvcMsgContext.STATUS_AUTH_ERROR == pStatus)
		{
			return "STATUS_AUTH_ERROR (" + pStatus + ")";
		}
		return "unknown status " + pStatus;
	}

	public static String getSessionCookieInfo(SessionCookie pSessionCookie,
		IdShortenerListener pIdShortenerListener)
	{
		String vShortSessionId = SessionIdShortener.getShortSessionId(
			pSessionCookie.getSessionId(), pIdShortenerListener);
		return "(" + vShortSessionId + ")";
	}

	public static String getPassivationFlags(int pFlags)
	{
		String vFlags = null;
		if ((pFlags & ApplicationModule.PASSIVATE_TRANSIENT_FLAG) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "PASSIVATE_TRANSIENT_FLAG";
		}
		if ((pFlags & ApplicationModule.PASSIVATE_DEFER_FLAG) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "PASSIVATE_DEFER_FLAG";
		}
		if ((pFlags & ApplicationModule.PASSIVATE_UNDO_FLAG) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "PASSIVATE_UNDO_FLAG";
		}
		if ((pFlags & ApplicationModule.PASSIVATE_HINT_FLAG) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "PASSIVATE_HINT_FLAG";
		}
		if ((pFlags & ApplicationModule.PASSIVATE_TO_STACK_FLAG) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "PASSIVATE_TO_STACK_FLAG";
		}
		return (vFlags != null ? vFlags : "unknown passivation flags")
			+ " (" + pFlags + ")";
	}

	public static String getAfterActivationActivationMode(int pActivationMode)
	{
		if (WSApplicationModuleMarshaller.ACTIVATION_NONE == pActivationMode)
		{
			return "ACTIVATION_NONE (" + pActivationMode + ")";
		}
		if (WSApplicationModuleMarshaller.ACTIVATION_AFTER_RESTART == pActivationMode)
		{
			return "ACTIVATION_AFTER_RESTART (" + pActivationMode + ")";
		}
		if (WSApplicationModuleMarshaller.ACTIVATION_AFTER_LOSS_OF_AFFINITY == pActivationMode)
		{
			return "ACTIVATION_AFTER_LOSS_OF_AFFINITY (" + pActivationMode + ")";
		}
		return "unknown activation mode " + pActivationMode;
	}

	public static String getResetFlags(int pFlags)
	{
		String vFlags = null;
		if ((pFlags & ApplicationModule.RESET_ROLLBACK_FLAG) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "RESET_ROLLBACK_FLAG";
		}
		if ((pFlags & ApplicationModule.RESET_RELOAD_FLAG) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "RESET_RELOAD_FLAG";
		}
		if ((pFlags & ApplicationModule.RESET_MANAGE_SNAPSHOTS) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "RESET_MANAGE_SNAPSHOTS";
		}
		if ((pFlags & ApplicationModule.RESET_KEEP_ALL_SNAPSHOTS_FLAG) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "RESET_KEEP_ALL_SNAPSHOTS_FLAG";
		}
		if ((pFlags & ApplicationModule.RESET_CLIENT_ONLY_FLAG) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "RESET_CLIENT_ONLY_FLAG";
		}
		if ((pFlags & ApplicationModule.RESET_INTERNAL_FLAG) > 0)
		{
			vFlags = (vFlags != null ? vFlags + ", " : "") + "RESET_INTERNAL_FLAG";
		}
		return (vFlags != null ? vFlags : "unknown passivation flags")
			+ " (" + pFlags + ")";
	}

	public static String getReleaseLevel(int pReleaseLevel)
	{
		if (ApplicationModule.RELEASE_LEVEL_MANAGED == pReleaseLevel)
		{
			return "RELEASE_LEVEL_MANAGED (" + pReleaseLevel + ")";
		}
		if (ApplicationModule.RELEASE_LEVEL_RESERVED == pReleaseLevel)
		{
			return "RELEASE_LEVEL_RESERVED (" + pReleaseLevel + ")";
		}
		if (ApplicationModule.RELEASE_LEVEL_UNMANAGED == pReleaseLevel)
		{
			return "RELEASE_LEVEL_UNMANAGED (" + pReleaseLevel + ")";
		}
		return "unknown release level " + pReleaseLevel;
	}
}
