package myapplicationmodulelistenerapp.common;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import javax.management.MBeanServerConnection;

import oracle.jbo.ApplicationPoolSvcMsgContext;
import oracle.jbo.Session;
import oracle.jbo.SessionData;
import oracle.jbo.common.NamedObjectImpl;
import oracle.jbo.common.SvcMsgRequestParams;
import oracle.jbo.common.ampool.ApplicationPool;
import oracle.jbo.common.ampool.SessionCookie;
import oracle.jbo.server.ApplicationModuleImpl;
import oracle.jbo.server.TransactionEvent;

import oracle.xml.parser.v2.XMLDocument;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import weblogic.management.runtime.JDBCDataSourceRuntimeMBean;

public class MyApplicationModuleListenerBaseImpl
	implements MyApplicationModuleListener
{
	public static final String LINE_SEPARATOR = System.getProperty("line.separator");

	public static final String SYS_CONTEXT_SID_SQL =
		"select sys_context('USERENV', 'SID') as sid from dual";

	protected IdShortenerListener fLogIdShortenerListener =
		new IdShortenerListener()
		{
			public void onNewShortId(String pNewShortId, Object pId)
			{
				log("onNewShortId() : pNewShortId = " + pNewShortId
					+ ", pId = " + pId);
			}
		};

	public MyApplicationModuleListenerBaseImpl()
	{
		super();
	}

	public void onNewConstruction(ApplicationModuleImpl pApplicationModuleImpl)
	{
		log("onNewConstruction() : " + getAMInfo(pApplicationModuleImpl));
	}

	public void onCreate(ApplicationModuleImpl pApplicationModuleImpl)
	{
		log("onCreate() : " + getAMInfo(pApplicationModuleImpl));
	}

	public void onPrepareSession(ApplicationModuleImpl pApplicationModuleImpl,
		Session pSession)
	{
		log("onPrepareSession() : " + getAMInfo(pApplicationModuleImpl));
	}

	public void onAfterConnect(ApplicationModuleImpl pApplicationModuleImpl)
	{
		log("onAfterConnect() : " + getAMInfo(pApplicationModuleImpl));
	}

	public void onBeforeDisconnect(ApplicationModuleImpl pApplicationModuleImpl)
	{
		log("onBeforeDisconnect() : " + getAMInfo(pApplicationModuleImpl));
	}

	public void onBeforeDoPoolMessage(ApplicationModuleImpl pApplicationModuleImpl,
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		log("onBeforeDoPoolMessage() : " + getAMInfo(pApplicationModuleImpl)
			+ "" + getApplicationPoolSvcMsgContextInfo(pApplicationPoolSvcMsgContext));
	}

	public void onAfterDoPoolMessage(ApplicationModuleImpl pApplicationModuleImpl,
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		log("onAfterDoPoolMessage() : " + getAMInfo(pApplicationModuleImpl)
			+ "" + getApplicationPoolSvcMsgContextInfo(pApplicationPoolSvcMsgContext));
	}

	public void onRemove(ApplicationModuleImpl pApplicationModuleImpl)
	{
		log("onRemove() : " + getAMInfo(pApplicationModuleImpl));
	}

	public void onProcessChangeNotifications(ApplicationModuleImpl pApplicationModuleImpl)
	{
		log("onProcessChangeNotifications() : " + getAMInfo(pApplicationModuleImpl));
	}

	public void onReset(ApplicationModuleImpl pApplicationModuleImpl)
	{
		log("onReset() : " + getAMInfo(pApplicationModuleImpl));
	}

	public void onResetState(ApplicationModuleImpl pApplicationModuleImpl,
		boolean pReload)
	{
		log("onResetState() : " + getAMInfo(pApplicationModuleImpl)
			+ " reload = " + pReload);
	}

	public void onResetState(ApplicationModuleImpl pApplicationModuleImpl,
		int pFlags)
	{
		log("onResetState() : " + getAMInfo(pApplicationModuleImpl)
			+ " flags = " + getResetFlags(pFlags));
	}

	public void onSetParent(ApplicationModuleImpl pApplicationModuleImpl,
		NamedObjectImpl pParent)
	{
		log("onSetParent() : " + getAMInfo(pApplicationModuleImpl)
			+ " parent = " + getNOInfo(pParent));
	}

	public void onSetParent(ApplicationModuleImpl pApplicationModuleImpl,
		oracle.jbo.server.NamedObjectImpl pParent)
	{
		log("onSetParent() : 2 : " + getAMInfo(pApplicationModuleImpl)
			+ " parent = " + getNOInfo(pParent));
	}

	public void onSetReleaseLevel(ApplicationModuleImpl pApplicationModuleImpl,
		int pReleaseLevel)
	{
		log("onSetReleaseLevel() : " + getAMInfo(pApplicationModuleImpl)
			+ " release level = " + pReleaseLevel);
	}

	public void onSetSessionUserData(ApplicationModuleImpl pApplicationModuleImpl,
		Hashtable pHashtable)
	{
		log("onSetSessionUserData() : " + getAMInfo(pApplicationModuleImpl)
			+ " hash table size = " + (pHashtable != null ? pHashtable.size() : null));
	}

	public void onActivate(ApplicationModuleImpl pApplicationModuleImpl,
		Session pSession)
	{
		log("onActivate() : " + getAMInfo(pApplicationModuleImpl)
			+ getSessionInfo(pSession));
	}

	public void onActivateConnectionState(ApplicationModuleImpl pApplicationModuleImpl,
		Element pParent)
	{
		log("onActivateConnectionState() : " + getAMInfo(pApplicationModuleImpl)
			+ " pParent = " + getElementInfo(pParent));
	}

	public void onActivateOpenVOs(ApplicationModuleImpl pApplicationModuleImpl,
		XMLDocument pOut)
	{
		log("onActivateOpenVOs() : " + getAMInfo(pApplicationModuleImpl)
			+ " pOut = " + getDocumentInfo(pOut));
	}

	public void onActivateState(ApplicationModuleImpl pApplicationModuleImpl,
		Element pParent)
	{
		log("onActivateState() : 1 : " + getAMInfo(pApplicationModuleImpl)
			+ " pParent = " + getElementInfo(pParent));
	}

	public void onActivateState(ApplicationModuleImpl pApplicationModuleImpl,
		int pId, boolean pRemove)
	{
		log("onActivateState() : 2 : " + getAMInfo(pApplicationModuleImpl)
			+ " pId = " + pId
			+ ", pRemove = " + pRemove);
	}

	public void onActivateState(ApplicationModuleImpl pApplicationModuleImpl,
		int pId, boolean pRemove, SessionData pInfo)
	{
		log("onActivateState() : 3 : " + getAMInfo(pApplicationModuleImpl)
			+ " pId = " + pId
			+ ", pRemove = " + pRemove
			+ ", session data = " + pInfo);
	}

	public void onActivateState(ApplicationModuleImpl pApplicationModuleImpl,
		int pId, SessionData pInfo, int pFlags)
	{
		log("onActivateState() : 4 : " + getAMInfo(pApplicationModuleImpl)
			+ " pId = " + pId
			+ ", session data = " + pInfo
			+ ", pFlags = " + pFlags);
	}

	public void onActivateStateForUndo(ApplicationModuleImpl pApplicationModuleImpl,
		String pId, int pFlags)
	{
		log("onActivateStateForUndo() : " + getAMInfo(pApplicationModuleImpl)
			+ " pId = " + pId
			+ ", pFlags = " + pFlags);
	}

	public void onAfterActivation(ApplicationModuleImpl pApplicationModuleImpl,
		int pActivationMode)
	{
		log("onAfterActivation() : " + getAMInfo(pApplicationModuleImpl)
			+ " pActivationMode = " + getAfterActivationActivationMode(pActivationMode));
	}

	public void onAfterCommit(ApplicationModuleImpl pApplicationModuleImpl,
		TransactionEvent pTransactionEvent)
	{
		log("onAfterCommit() : " + getAMInfo(pApplicationModuleImpl)
			+ " pTransactionEvent = " + pTransactionEvent);
	}

	public void onAfterRollback(ApplicationModuleImpl pApplicationModuleImpl,
		TransactionEvent pTransactionEvent)
	{
		log("onAfterRollback() : " + getAMInfo(pApplicationModuleImpl)
			+ " pTransactionEvent = " + pTransactionEvent);
	}

	public void onBeforeCommit(ApplicationModuleImpl pApplicationModuleImpl,
		TransactionEvent pTransactionEvent)
	{
		log("onBeforeCommit() : " + getAMInfo(pApplicationModuleImpl)
			+ " pTransactionEvent = " + pTransactionEvent);
	}

	public void onBeforeRollback(ApplicationModuleImpl pApplicationModuleImpl,
		TransactionEvent pTransactionEvent)
	{
		log("onBeforeRollback() : " + getAMInfo(pApplicationModuleImpl)
			+ " pTransactionEvent = " + pTransactionEvent);
	}

	public void onClearVOCaches(ApplicationModuleImpl pApplicationModuleImpl,
		String pEntityName, boolean pRecurse)
	{
		log("onClearVOCaches() : " + getAMInfo(pApplicationModuleImpl)
			+ " pEntityName = " + pEntityName
			+ ", pRecurse = " + pRecurse);
	}

	public void onPassivateConnectionState(ApplicationModuleImpl pApplicationModuleImpl,
		Document pDoc, Element pParent)
	{
		log("onPassivateConnectionState() : " + getAMInfo(pApplicationModuleImpl)
			+ " pDoc = " + getDocumentInfo(pDoc)
			+ ", pParent = " + getElementInfo(pParent));
	}

	public void onPassivateOpenVOs(ApplicationModuleImpl pApplicationModuleImpl,
		boolean pClose)
	{
		log("onPassivateOpenVOs() : " + getAMInfo(pApplicationModuleImpl)
			+ " pClose = " + pClose);
	}

	public void onPassivateState(ApplicationModuleImpl pApplicationModuleImpl,
		byte[] pClientData)
	{
		log("onPassivateState() : 1 : " + getAMInfo(pApplicationModuleImpl)
			+ " pClientData = " + getClientDataInfo(pClientData));
	}

	public void onPassivateState(ApplicationModuleImpl pApplicationModuleImpl,
		byte[] pClientData, int pFlags)
	{
		log("onPassivateState() : 2 : " + getAMInfo(pApplicationModuleImpl)
			+ " pClientData = " + getClientDataInfo(pClientData)
			+ ", pFlags = " + getPassivationFlags(pFlags));
	}

	public void onPassivateState(ApplicationModuleImpl pApplicationModuleImpl,
		Document pDoc, Element pParent)
	{
		log("onPassivateState() : 3 : " + getAMInfo(pApplicationModuleImpl)
			+ " pDoc = " + getDocumentInfo(pDoc)
			+ ", pParent = " + getElementInfo(pParent));
	}

	public void onPassivateState(ApplicationModuleImpl pApplicationModuleImpl,
		int pId, byte[] pClientData)
	{
		log("onPassivateState() : 4 : " + getAMInfo(pApplicationModuleImpl)
			+ " pId = " + pId
			+ ", pClientData = " + getClientDataInfo(pClientData));
	}

	public void onPassivateState(ApplicationModuleImpl pApplicationModuleImpl,
		int pId, byte[] pClientData, int pFlags)
	{
		log("onPassivateState() : 5 : " + getAMInfo(pApplicationModuleImpl)
			+ " pId = " + pId
			+ ", pClientData = " + getClientDataInfo(pClientData)
			+ ", pFlags = " + getPassivationFlags(pFlags));
	}

	public void onPassivateStateForUndo(ApplicationModuleImpl pApplicationModuleImpl,
		String pId, byte[] pClientData, int pFlags)
	{
		log("onPassivateStateForUndo() : " + getAMInfo(pApplicationModuleImpl)
			+ " pId = " + pId
			+ ", pClientData = " + getClientDataInfo(pClientData)
			+ ", pFlags = " + getPassivationFlags(pFlags));
	}

	public void onPrepareForActivation(ApplicationModuleImpl pApplicationModuleImpl,
		Element pAmNode)
	{
		log("onPrepareForActivation() : " + getAMInfo(pApplicationModuleImpl)
			+ " pAmNode = " + getElementInfo(pAmNode));
	}

	public void onPrepareForPassivation(ApplicationModuleImpl pApplicationModuleImpl,
		Document pOut, Element pParent)
	{
		log("onPrepareForPassivation() : " + getAMInfo(pApplicationModuleImpl)
			+ " pOut = " + getDocumentInfo(pOut)
			+ " pParent = " + getElementInfo(pParent));
	}

	public void onAfterRequest()
	{
		List<ApplicationPool> vAllApplicationPools = null;
		try
		{
			vAllApplicationPools = PoolMgrHelper.getAllApplicationPools();
		}
		catch (Exception ex)
		{
			throw new RuntimeException(
				"unable to get all ApplicationPools, ex = " + ex, ex);
		}
		if (vAllApplicationPools.size() < 1)
		{
			log("onAfterRequest() : no ApplicationPools");
		}
		int vCounter = 1;
		for (ApplicationPool vApplicationPool : vAllApplicationPools)
		{
			log("onAfterRequest() : " + (vCounter++)
				+ " : ApplicationPool = " + vApplicationPool.getName()
				+ getAfterRequestApplicationPoolInfo(vApplicationPool));
		}
	}

	public void log(String pInformation)
	{
		String vLineNumber = getNextLineNumber();
		System.out.println(vLineNumber + getLogPrefix()
			+ addLineNumbers(pInformation));
	}

	protected String getNextLineNumber()
	{
		return LineNumberHelper.getNextLineNumber();
	}

	protected String addLineNumbers(String pLinesString)
	{
		if (pLinesString == null)
		{
			return null;
		}
		String[] vLines = pLinesString.split(LINE_SEPARATOR);
		String vNumberedLines = vLines[0]; // no number added to the first line
		int vIndex = 1;
		while(vIndex < vLines.length)
		{
			vNumberedLines = vNumberedLines
				+ LINE_SEPARATOR + getNextLineNumber() + vLines[vIndex];
			vIndex = vIndex + 1;
		}
		return vNumberedLines;
	}

	protected String getLogPrefix()
	{
		return "[L]";
	}

	protected String getAMInfo(ApplicationModuleImpl pApplicationModuleImpl)
	{
		return MyAMInfoHelper.getAMInfo(pApplicationModuleImpl);
	}

	protected String getNOInfo(NamedObjectImpl pNamedObjectImpl)
	{
		return MyAMInfoHelper.getNOInfo(pNamedObjectImpl);
	}

	public String getAfterRequestApplicationPoolInfo(
		ApplicationPool pApplicationPool)
	{
		PoolMgrHelper vPoolMgrHelper = getPoolMgrHelper();
		String vStatisticsInOneLine =
			vPoolMgrHelper.getStatisticsInOneLine(pApplicationPool);
		String vJDBCDataSourceInfo =
			getAfterRequestApplicationPoolJDBCDataSourceInfo(pApplicationPool);
		return LINE_SEPARATOR + vStatisticsInOneLine
			+ (vJDBCDataSourceInfo != null ? LINE_SEPARATOR + vJDBCDataSourceInfo : "");
	}

	public String getAfterRequestApplicationPoolJDBCDataSourceInfo(
		ApplicationPool pApplicationPool)
	{
		PoolMgrHelper vPoolMgrHelper = getPoolMgrHelper();
		String vJDBCDataSourceName =
			vPoolMgrHelper.getJDBCDataSourceName(pApplicationPool);
		if (vJDBCDataSourceName != null)
		{
			String vJDBCDataSourceRuntimeMBeanName =
				getJDBCDataSourceRuntimeMBeanNameForJDBCDataSourceName(
					vJDBCDataSourceName);
			String vShortDataSourceId = getShortDataSourceId(vJDBCDataSourceName,
				vJDBCDataSourceRuntimeMBeanName);
			MBeanServerConnection vMBeanServerConnection = getMBeanServerConnection();
			JDBCDataSourceRuntimeMBean vJDBCDataSourceRuntimeMBean =
				getProxyJDBCDataSourceRuntimeMBean(
					vMBeanServerConnection, vJDBCDataSourceRuntimeMBeanName);
			return "(" + vShortDataSourceId + ")"
				+ getJDBCDataSourceRuntimeMBeanInfo(vJDBCDataSourceRuntimeMBean);
		}
		return null;
	}

	public String getJDBCDataSourceRuntimeMBeanNameForJDBCDataSourceName(
		String pJDBCDataSourceName)
	{
		// TODO review this (first part of a) buggy workaround,
		// and replace it with a proper generic solution
		// see also forum thread "finding runtime MBean for DataSource JNDI name"
		// at https://forums.oracle.com/forums/thread.jspa?threadID=2358275
		MBeanServerConnection vMBeanServerConnection = getMBeanServerConnection();
		return MyMBeanHelper.getFirstJDBCDataSourceRuntimeMBeanName(
			vMBeanServerConnection);
	}

	public String getShortDataSourceId(String pJDBCDataSourceName,
		String pJDBCDataSourceRuntimeMBeanName)
	{
		String vDataSourceId = pJDBCDataSourceName
			+ " - " + pJDBCDataSourceRuntimeMBeanName;
		return DataSourceIdShortener.getShortDataSourceId(vDataSourceId,
			getDataSourceIdShortenerListener());
	}

	public IdShortenerListener getDataSourceIdShortenerListener()
	{
		return fLogIdShortenerListener;
//		return IdShortenerListener.IGNORE_ID_SHORTENER_LISTENER;
	}

	public MBeanServerConnection getMBeanServerConnection()
	{
		return MyMBeanHelper.lookupMBeanServerConnectionRuntime();
	}

	public JDBCDataSourceRuntimeMBean getProxyJDBCDataSourceRuntimeMBean(
		MBeanServerConnection pMBeanServerConnection,
		String pJDBCDataSourceRuntimeMBeanName)
	{
		return MyMBeanHelper.getProxyJDBCDataSourceRuntimeMBean(
			pMBeanServerConnection, pJDBCDataSourceRuntimeMBeanName);
	}

	public String getJDBCDataSourceRuntimeMBeanInfo(
		JDBCDataSourceRuntimeMBean pJDBCDataSourceRuntimeMBean)
	{
		return MyMBeanHelper.getJDBCDataSourceRuntimeMBeanInfo(
			pJDBCDataSourceRuntimeMBean);
	}

	public String getApplicationPoolSvcMsgContextInfo(
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		return "["
			+ getSessionCookieInfo(pApplicationPoolSvcMsgContext)
			+ getApplicationPoolSvcMsgContextMessageType(pApplicationPoolSvcMsgContext)
			+ getApplicationPoolSvcMsgContextStatus(pApplicationPoolSvcMsgContext)
//			+ getApplicationPoolSvcMsgContextJDBCInfo(pApplicationPoolSvcMsgContext)
			+ getApplicationPoolSvcMsgContextRequestInfo(pApplicationPoolSvcMsgContext)
//			+ getApplicationPoolSvcMsgContextRtnEventList(pApplicationPoolSvcMsgContext)
			+ getApplicationPoolSvcMsgContextMiscellaneous(pApplicationPoolSvcMsgContext)
			+ "]"
			+ getStatisticsInOneLine(pApplicationPoolSvcMsgContext);
	}

	public String getStatisticsInOneLine(
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		SessionCookie vSessionCookie =
			pApplicationPoolSvcMsgContext.getSessionCookie();
		return LINE_SEPARATOR + getStatisticsInOneLine(vSessionCookie);
	}

	public String getStatisticsInOneLine(SessionCookie pSessionCookie)
	{
		PoolMgrHelper vPoolMgrHelper = getPoolMgrHelper();
		return vPoolMgrHelper.getStatisticsInOneLine(pSessionCookie);
	}

	public PoolMgrHelper getPoolMgrHelper()
	{
		return PoolMgrHelper.getDefaultInstance();
//		return new PoolMgrHelper()
//			{
//				public IdShortenerListener getIdShortenerListener()
//				{
//					return fLogIdShortenerListener;
//				}
//			};
	}

	public String getSessionCookieInfo(
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		SessionCookie vSessionCookie = pApplicationPoolSvcMsgContext.getSessionCookie();
		return getSessionCookieInfo(vSessionCookie);
	}

	public String getSessionCookieInfo(SessionCookie pSessionCookie)
	{
		return MyAMInfoHelper.getSessionCookieInfo(pSessionCookie,
			getIdShortenerListener());
	}

	public IdShortenerListener getIdShortenerListener()
	{
//		return fLogIdShortenerListener;
		return IdShortenerListener.IGNORE_ID_SHORTENER_LISTENER;
	}

	public String getApplicationPoolSvcMsgContextMessageType(
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		byte vMessageType = pApplicationPoolSvcMsgContext.getMessageType();
		return " " + MyAMInfoHelper.getApplicationPoolSvcMsgContextMessageType(vMessageType);
	}

	public String getApplicationPoolSvcMsgContextStatus(
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		int vStatus = pApplicationPoolSvcMsgContext.getStatus();
		return " " + MyAMInfoHelper.getApplicationPoolSvcMsgContextStatus(vStatus);
	}

	public String getApplicationPoolSvcMsgContextJDBCInfo(
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		byte vJDBCConnectionType = pApplicationPoolSvcMsgContext.getJDBCConnectionType();
		String vJDBCConnectionTypeString =
			MyAMInfoHelper.getApplicationPoolSvcMsgContextJDBCConnectionType(vJDBCConnectionType);
		String vJDBCDataSourceName = pApplicationPoolSvcMsgContext.getJDBCDataSourceName();
		String vJDBCDataSourceUser = pApplicationPoolSvcMsgContext.getJDBCDataSourceUser();
		return " " + vJDBCConnectionTypeString
			+ (vJDBCConnectionType == ApplicationPoolSvcMsgContext.JDBC_DATASOURCE_CONNECTION_TYPE ?
				" " + vJDBCDataSourceName + " user " + vJDBCDataSourceUser : "");
	}

	public String getApplicationPoolSvcMsgContextRequestInfo(
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		int vRequestPointer = pApplicationPoolSvcMsgContext.getRequestPointer();
		SvcMsgRequestParams vRequest = pApplicationPoolSvcMsgContext.getRequest();
		String vRequestString = "(message request == null)";
		if (vRequest != null)
		{
			int vRequestOperation = vRequest.getOperation();
			vRequestString =
				MyAMInfoHelper.getApplicationPoolSvcMsgContextRequestOperation(vRequestOperation);
		}
		return " (rp " + vRequestPointer + ")"
//			+ " " + vRequestString
			;
	}

	public String getApplicationPoolSvcMsgContextRtnEventList(
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		ArrayList vRtnEventList = pApplicationPoolSvcMsgContext.getRtnEventList();
		String vRtnEventListString = null;
		if (vRtnEventList != null)
		{
			for (Object vEventIdObject : vRtnEventList)
			{
				Integer vEventId = (Integer)vEventIdObject;
				vRtnEventListString =
					(vRtnEventListString != null ? vRtnEventListString + " - " :  "")
					+ MyAMInfoHelper.getApplicationPoolSvcMsgContextRtnEventId(vEventId);
			}
			if (vRtnEventListString == null)
			{
				vRtnEventListString = "(event list empty)";
			}
		}
		else
		{
			vRtnEventListString = "(event list == null)";
		}
		return " " + vRtnEventListString;
	}

	public String getApplicationPoolSvcMsgContextMiscellaneous(
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
//		boolean vIsApplicationModuleConnected =
//			pApplicationPoolSvcMsgContext.isApplicationModuleConnected();
//		boolean vIsApplicationModuleRemoved =
//			pApplicationPoolSvcMsgContext.isApplicationModuleRemoved();
//		boolean vIsRetainState = pApplicationPoolSvcMsgContext.isRetainState();
//		boolean vIsUseExclusive = pApplicationPoolSvcMsgContext.isUseExclusive();
//		return " (" + (vIsApplicationModuleConnected ? "" : "not ") + "AM connected)"
//			+ " (" + (vIsApplicationModuleRemoved ? "" : "not ") + "AM removed)"
//			+ " (" + (vIsRetainState ? "" : "not ") + "retain state)"
//			+ " (" + (vIsUseExclusive ? "" : "not ") + "use exclusive)";
		return "";
	}

	public String getSessionInfo(Session pSession)
	{
		return "(session"
			+ " version " + (pSession != null ? pSession.getVersion() : null)
			+ " " + pSession
			+ ")";
	}

	public String getPassivationFlags(int pFlags)
	{
		return MyAMInfoHelper.getPassivationFlags(pFlags);
	}

	public String getClientDataInfo(byte[] pClientData)
	{
		if (pClientData == null)
		{
			return null;
		}
		return "(length = " + pClientData.length + ")";
	}

	public String getDocumentInfo(Document pDocument)
	{
		if (pDocument == null)
		{
			return null;
		}
		String vNodeName = pDocument.getNodeName();
//		short vNodeType = pDocument.getNodeType();
//		String vNamespaceURI = pDocument.getNamespaceURI();
		Element vDocumentElement = pDocument.getDocumentElement();
		return "(name = " + vNodeName
//			+ ", type = " + vNodeType
//			+ ", ns = " + vNamespaceURI
			+ ", doc elem = " + getElementInfo(vDocumentElement)
			+ ")";
	}

	public String getElementInfo(Element pElement)
	{
		if (pElement == null)
		{
			return null;
		}
		String vNodeName = pElement.getNodeName();
//		short vNodeType = pElement.getNodeType();
//		String vNamespaceURI = pElement.getNamespaceURI();
		return "(name = " + vNodeName
//			+ ", type = " + vNodeType
//			+ ", ns = " + vNamespaceURI
			+ ")";
	}

	public String getAfterActivationActivationMode(int pActivationMode)
	{
		return MyAMInfoHelper.getAfterActivationActivationMode(pActivationMode);
	}

	public String getResetFlags(int pFlags)
	{
		return MyAMInfoHelper.getResetFlags(pFlags);
	}

	public String queryOneRecord(
		ApplicationModuleImpl pApplicationModuleImpl, String pSQL)
	{
		return MyAMInfoHelper.queryOneRecord(pApplicationModuleImpl, pSQL);
	}
}
