package myapplicationmodulelistenerapp.view;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

import myapplicationmodulelistenerapp.common.MyApplicationModuleListener;
import myapplicationmodulelistenerapp.common.MyRequestContext;

import oracle.adf.share.ADFContext;

import oracle.jbo.ApplicationPoolSvcMsgContext;
import oracle.jbo.server.ApplicationModuleImpl;


public class MyApplicationModuleListenerFilter
	implements Filter
{
	protected FilterConfig fFilterConfig = null;

	public class MyFilterMAMListener
		extends MyPrefixInfoMyApplicationModuleListener
	{
		public MyFilterMAMListener(String pPrefix, String pInfo)
		{
			super(pPrefix, pInfo);
		}

		@Override
		public void onBeforeDoPoolMessage(ApplicationModuleImpl pApplicationModuleImpl,
			ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
		{}
	
		@Override
		public String getStatisticsInOneLine(
			ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
		{
			return "";
		}
	}

	public void init(FilterConfig pFilterConfig)
		throws ServletException
	{
		fFilterConfig = pFilterConfig;
	}

	public void destroy()
	{
		fFilterConfig = null;
	}

	public void doFilter(ServletRequest pRequest, ServletResponse pResponse,
		FilterChain pFilterChain)
		throws IOException, ServletException
	{
		MyRequestContext vMyRequestContext = MyRequestContext.getCurrentInstance();
		// to "clean up" and listen before (the JSF lifecycle)
		vMyRequestContext.setMyApplicationModuleListener(
			getBeforeMAMListener(pRequest, pResponse));

		pFilterChain.doFilter(pRequest, pResponse);

		HttpServletRequest vHttpServletRequest = (HttpServletRequest)pRequest;
		ADFContext.initADFContext(fFilterConfig.getServletContext(),
			vHttpServletRequest.getSession(), pRequest, pResponse);

		vMyRequestContext = MyRequestContext.getCurrentInstance(); // should be the same as before
		MyApplicationModuleListener vMyApplicationModuleListener =
			vMyRequestContext.getMyApplicationModuleListener();
		vMyApplicationModuleListener.onAfterRequest();

		// to "clean up" and listen after (the JSF lifecycle)
		vMyRequestContext.setMyApplicationModuleListener(
			getAfterMAMListener(pRequest, pResponse));
	}

	protected MyApplicationModuleListener getBeforeMAMListener(
		ServletRequest pRequest, ServletResponse pResponse)
	{
		HttpServletRequest vHttpServletRequest = (HttpServletRequest)pRequest;
		return new MyFilterMAMListener("L-before",
			getRequestInfo(vHttpServletRequest));
	}

	protected MyApplicationModuleListener getAfterMAMListener(
		ServletRequest pRequest, ServletResponse pResponse)
	{
		// note request information in this "after" listener could cause confusion
		return new MyFilterMAMListener("L-after", "[(" + getMyRequestContextId() + ")]");
	}

	protected String getRequestInfo(HttpServletRequest pRequest)
	{
		String vServletPath = pRequest.getServletPath();
		String vPathInfo = pRequest.getPathInfo();
		return "[(" + getMyRequestContextId() + ") "
			+ vServletPath + " : " + vPathInfo + "] ";
	}

	protected String getMyRequestContextId()
	{
		MyRequestContext vMyRequestContext = MyRequestContext.getCurrentInstance();
		return vMyRequestContext.getMyRequestContextId();
	}
}
