package myapplicationmodulelistenerapp.view;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;

import java.net.URLEncoder;

import java.util.List;

import javax.management.MBeanServerConnection;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import myapplicationmodulelistenerapp.common.MyMBeanHelper;


public class MyQueryMBeansObjectsServlet
	extends HttpServlet
{
	private static final String CONTENT_TYPE = "text/html; charset=UTF-8";

	public static String fSelectedObjectName = null;

	public void init(ServletConfig pConfig)
		throws ServletException
	{
		super.init(pConfig);
	}

	public void doGet(HttpServletRequest pRequest,
		HttpServletResponse pResponse)
		throws ServletException, IOException
	{
		pResponse.setContentType(CONTENT_TYPE);
		PrintWriter vOut = pResponse.getWriter();
		vOut.println("<html>");
		vOut.println("<head><title>MyQueryMBeansObjectsServlet</title></head>");
		vOut.println("<body>");
		vOut.println("<div>MyQueryMBeansObjectsServlet</div>");

		String vQueryObjectName = pRequest.getParameter("pQueryObjectName");

		String vSelectedObjectName = pRequest.getParameter("pSelectedObjectName");
		if (vSelectedObjectName != null)
		{
			fSelectedObjectName = vSelectedObjectName;
		}

		printQueryForm(vOut, vQueryObjectName);
		vOut.println("<div>getSelectedObjectName() = "
			+ getSelectedObjectName() + "</div>");
		if (vQueryObjectName != null)
		{
			MBeanServerConnection vMBeanServerConnection =
				MyMBeanHelper.lookupMBeanServerConnectionRuntime();
			List<String> vMBeansObjectsNames = MyMBeanHelper.queryMBeansObjects(
				vMBeanServerConnection, vQueryObjectName);
			printMBeansObjectsNames(pRequest, vOut, vMBeansObjectsNames);
		}

		vOut.println("</body></html>");
		vOut.close();
	}

	public static String getSelectedObjectName()
	{
		return fSelectedObjectName;
	}

	protected void printQueryForm(PrintWriter pOut, String pQueryObjectName)
	{
		String vQueryObjectName = (pQueryObjectName != null ?
			pQueryObjectName : getDefaultQueryObjectName());
		pOut.println("<form method=\"GET\">");
		pOut.println("<input type=\"text\" name=\"pQueryObjectName\" value=\""
			+ vQueryObjectName + "\" size=\"100\">");
		pOut.println("<input type=\"submit\" value=\"query\">");
		pOut.println("</form>");
	}

	protected String getDefaultQueryObjectName()
	{
		return MyMBeanHelper.JDBCDATASOURCERUNTIME_QUERYOBJECTNAME;
	}

	protected void printMBeansObjectsNames(HttpServletRequest pRequest,
		PrintWriter pOut, List<String> pMBeansObjectsNames)
	{
		pOut.println("<div>MBean object names : "
			+ pMBeansObjectsNames.size() + "</div>");
		pOut.println("<ul>");
		for (String vName : pMBeansObjectsNames)
		{
			String vSelectURL = getSelectURL(pRequest, vName);
			pOut.println("<li><a href=\"" + vSelectURL + "\">" + vName + "</a></li>");
		}
		pOut.println("</ul>");
	}

	protected String getSelectURL(HttpServletRequest pRequest, String pName)
	{
		String vContextPath = pRequest.getContextPath();
		String vServletPath = pRequest.getServletPath();
		return vContextPath + vServletPath
			+ "?pSelectedObjectName=" + getURLEncoded(pName);
	}

	protected String getURLEncoded(String pString)
	{
		try
		{
			return URLEncoder.encode(pString, "UTF-8");
		}
		catch (UnsupportedEncodingException ex)
		{
			throw new RuntimeException("unable to URL encode, ex = " + ex);
		}
	}
}
